#define RELATION_CHANGE_PROBABILITY 1 // PB: Percentage chance of relation change per day, accepts 0.1 increments

int NATIONS_QUANTITY = 0; // KK

extern void InitNations();
extern void relations_init(); // KK
extern void groups_init(); // KK

#event_handler(GET_RELATION_EVENT,"GetRelationEvent");

void Nations_SetAllFriends()
{
	int i;

	for(i = 0; i < MAX_NATIONS_SQR; i++)
	{
		NationsRelations[i] = RELATION_FRIEND;
	}

	for (i = 0; i < MAX_NATIONS; i++)
	{
		NationsRelations2MainCharacter[i] = RELATION_FRIEND;
	}
}

void NationsInit()
{
	if(LoadSegment("nations\nations_init.c"))
	{
		InitNations();
		UnloadSegment("nations\nations_init.c");
	}

	Nations_SetAllFriends();
}

void SetNationRelation2MainCharacter(int iNation, int iRelationType)
{
	if (iNation >= 0 && iNation < NATIONS_QUANTITY) // KK
	NationsRelations2MainCharacter[iNation] = iRelationType;
}

void SetNationRelationBoth(int iNation1, int iNation2, int iRelationType)
{
	if (iNation1 >= 0 && iNation1 < NATIONS_QUANTITY && iNation2 >= 0 && iNation2 < NATIONS_QUANTITY) { // KK
		NationsRelations[iNation1 * NATIONS_QUANTITY + iNation2] = iRelationType;
		NationsRelations[iNation2 * NATIONS_QUANTITY + iNation1] = iRelationType;
	}
}

void SetNationRelation(int iNation1, int iNation2, int iRelationType)
{
	if (iNation1 >= 0 && iNation1 < NATIONS_QUANTITY && iNation2 >= 0 && iNation2 < NATIONS_QUANTITY) // KK
	NationsRelations[iNation1 * NATIONS_QUANTITY + iNation2] = iRelationType;
}

// =================================================================================================
// Character Relation
// =================================================================================================
void SetCharacterRelationAsOtherCharacter(int iCharacterIndex1, int iCharacterIndex2)
{
	Characters[iCharacterIndex1].relation.UseOtherCharacter = iCharacterIndex2;
}

void SetCharacterRelationBoth(int iCharacterIndex1, int iCharacterIndex2, int iRelationType)
{
	if (iCharacterIndex1 < 0 || iCharacterIndex2 < 0) return;
	SetCharacterRelation(iCharacterIndex1, iCharacterIndex2, iRelationType);
	SetCharacterRelation(iCharacterIndex2, iCharacterIndex1, iRelationType);
}

void SetCharacterRelation(int iCharacterIndex1, int iCharacterIndex2, int iRelationType)
{
	if (iCharacterIndex1 < 0) return; // KK, LDH 14Oct06 removed test for iCharacterIndex2<0
	string sTemp1 = "" + iCharacterIndex2;
	Characters[iCharacterIndex1].relation.(sTemp1) = iRelationType;
}

// =================================================================================================
// Get Relation Methods
// =================================================================================================
int GetNationRelation(int iNation1, int iNation2)
{
	if (iNation1 >= 0 && iNation1 < NATIONS_QUANTITY && iNation2 >= 0 && iNation2 < NATIONS_QUANTITY) // KK
	return NationsRelations[iNation1 * NATIONS_QUANTITY + iNation2];
	if (iNation1 == PERSONAL_NATION && iNation2 >= 0 && ination2 < NATIONS_QUANTITY) return NationsRelations2MainCharacter[iNation2]; // KK
	if (iNation2 == PERSONAL_NATION && iNation1 >= 0 && ination1 < NATIONS_QUANTITY) return NationsRelations2MainCharacter[iNation1]; // KK
	return RELATION_NEUTRAL; // KK
}

int GetNationRelation2MainCharacter(int iNation)
{
	if (iNation == PERSONAL_NATION) return RELATION_FRIEND; // KK
	// added by KAM -->
	if (iNation >= 0 && iNation < NATIONS_QUANTITY)	// LDH fix for iNation < 0
	{
		// PB: Use Actual Relations -->
		if(ENABLE_FLAGS)
		return GetRMRelationType(GetActualRMRelation(iNation));
		else
		return NationsRelations2MainCharacter[iNation];
		// PB: Use Actual Relations <--
	}
	else
	{
		return RELATION_NEUTRAL;
	}
	// <-- added by KAM
}

int GetNationRelation2Character(int iNation, int iCharacterIndex)
{
	ref rCharacter = GetCharacter(iCharacterIndex);

	if (CheckAttribute(&rCharacter, "relation.UseOtherCharacter"))
	{
		if (sti(rCharacter.relation.UseOtherCharacter) >= 0)
		{
			rCharacter = GetCharacter(sti(rCharacter.relation.UseOtherCharacter));
		}
	}

	int iMCI = GetMainCharacterIndex();
	int iNation2 = sti(rCharacter.nation);
	if (iNation >= NATIONS_QUANTITY || iNation2 >= NATIONS_QUANTITY) return RELATION_NEUTRAL; // NK for KAM extra nations 05-04-20 // KK
	if (iNation < 0 || iNation2 < 0) return RELATION_NEUTRAL;	// LDH fix for iNation < 0
	if (iMCI == sti(rCharacter.index))
	{
		return NationsRelations2MainCharacter[iNation];
	}
	return NationsRelations[iNation * NATIONS_QUANTITY + iNation2];
}

int GetRelation(int iCharacterIndex1, int iCharacterIndex2)
{
	bool ismc1, ismc2;
	int iNation1, iNation2;
	string stmp;
	int iMCI = GetMainCharacterIndex();

	ref rCharacter1 = GetCharacter(iCharacterIndex1);
	ref rCharacter2 = GetCharacter(iCharacterIndex2);

	if (CheckAttribute(&rCharacter1, "relation.UseOtherCharacter"))
	{
		if (sti(rCharacter1.relation.UseOtherCharacter) >= 0)
		{
			rCharacter1 = GetCharacter(sti(rCharacter1.relation.UseOtherCharacter));
		}
	}
	if (CheckAttribute(&rCharacter2, "relation.UseOtherCharacter"))
	{
		if (sti(rCharacter2.relation.UseOtherCharacter) >= 0)
		{
			rCharacter2 = GetCharacter(sti(rCharacter2.relation.UseOtherCharacter));
		}
	}

	if (sti(rCharacter1.index) == sti(rCharacter2.index)) return RELATION_FRIEND;

	// character 2 character relation
	{
		string sTemp = "relation." + rCharacter2.index;
		if (CheckAttribute(&rCharacter1,sTemp))
		{
			return sti(rCharacter1.(sTemp));
		}
	}
	//Trace("iNation1 = " + iNation1 + ", iNation2 = " + iNation2);

	iNation1 = sti(rCharacter1.nation);
	iNation2 = sti(rCharacter2.nation);

	if (iNation1 < PERSONAL_NATION || iNation2 < PERSONAL_NATION) return RELATION_NEUTRAL;	// LDH fix for iNation < 0
	if (iNation1 >= NATIONS_QUANTITY || iNation2 >= NATIONS_QUANTITY) return RELATION_NEUTRAL; // KK
	// 04-12-06 new section
	ismc1 = IsInParty(iMCI, sti(rCharacter1.index));
	ismc2 = IsInParty(iMCI, sti(rCharacter2.index));
	if(ismc1 && ismc2) return RELATION_FRIEND;

	if (iNation1 == NEUTRAL_NATION || iNation2 == NEUTRAL_NATION) return RELATION_NEUTRAL; // KK

	if (iNation1 == PERSONAL_NATION && iNation2 == PERSONAL_NATION) return RELATION_NEUTRAL; // PB
	if (iNation1 == PERSONAL_NATION && iNation2 < NATIONS_QUANTITY) return NationsRelations2MainCharacter[iNation2]; // KK
	if (iNation2 == PERSONAL_NATION && iNation1 < NATIONS_QUANTITY) return NationsRelations2MainCharacter[iNation1]; // KK

	if(iNation1 >= NATIONS_QUANTITY)
	{
		if(ismc1) //this should never be false...
		{
			iNation1 = RMGetHighestRelation(GetMainCharacter());
		}
		else return RELATION_NEUTRAL; // this case should never occur, since only pchar can set to >=maxnat.
	}
	if(iNation2 >= NATIONS_QUANTITY && iNation2 != PERSONAL_NATION) // KK
	{
		if(ismc2) //this should never be false...
		{
			iNation2 = RMGetHighestRelation(GetMainCharacter());
		}
		else return RELATION_NEUTRAL; // this case should never occur, since only pchar can set to >=maxnat.
	}

	// nation 2 character relation
	if(ismc1) //if (iMCI == sti(rCharacter1.index))
	{
		//Trace("iMainCharacterRelation = " + NationsRelations2MainCharacter[iNation2]);
		if (iNation2 == PERSONAL_NATION) return RELATION_FRIEND; // KK
		return NationsRelations2MainCharacter[iNation2];
	}
	if(ismc2) //if (iMCI == sti(rCharacter2.index))
	{
		//Trace("iMainCharacterRelation = " + NationsRelations2MainCharacter[iNation1]);
		if (iNation1 == PERSONAL_NATION) return RELATION_FRIEND; // KK
		return NationsRelations2MainCharacter[iNation1];
	}

	// nation 2 nation relation
	return NationsRelations[iNation1 * NATIONS_QUANTITY + iNation2];
}

int GetRelationEvent()
{
	int iCharacterIndex1 = GetEventData();
	int iCharacterIndex2 = GetEventData();
	return GetRelation(iCharacterIndex1, iCharacterIndex2);
}

int FindEnemyNation2Nation(int iNation)
{
	int iNations[MAX_NATIONS];
	int iNumNations = 0;

	for (int i=0;i<NATIONS_QUANTITY;i++)
	{
		if (GetNationRelation(i,iNation) == RELATION_ENEMY)
		{
			iNations[iNumNations] = i;
			iNumNations++;
		}
	}
	if (iNumNations == 0) return PIRATE;		// LDH fix
	return iNations[rand(iNumNations - 1)];
}

// NK add friendly/neutral case here too 04-09-09
int FindFriendlyNation2Nation(int iNation)
{
	int iNations[MAX_NATIONS];
	int iNumNations = 0;

	for (int i=0;i<NATIONS_QUANTITY;i++)
	{
		if (GetNationRelation(i,iNation) != RELATION_ENEMY)
		{
			iNations[iNumNations] = i;
			iNumNations++;
		}
	}
	if (iNumNations == 0) return PIRATE;		// LDH fix
	return iNations[rand(iNumNations - 1)];
}
// NK <--

int FindEnemyNation2Character(int iCharacterIndex)
{
	int iNations[MAX_NATIONS];
	int iNumNations = 0;

	for (int i=0; i<NATIONS_QUANTITY; i++)
	{
		if (GetNationRelation2Character(i, iCharacterIndex) == RELATION_ENEMY)
		{
			iNations[iNumNations] = i;
			iNumNations++;
		}
	}
	if (iNumNations == 0) return PIRATE;		// LDH fix
	return iNations[rand(iNumNations - 1)];
}

// KK -->
int GetNationTypeByID(string nationName)
{
	for(int i=0; i<NATIONS_QUANTITY; i++)
	{
		if (Nations[i].id == nationName) return i;
	}
	return -1;
}

string GetNationIDByType(int iNationType)
{
	if (iNationType >= 0 && iNationType < NATIONS_QUANTITY) return Nations[iNationType].id;
	if (iNationType == NEUTRAL_NATION) return "no nation";
	if (iNationType == UNKNOWN_NATION) return "unknown nation";
	if (iNationType == PERSONAL_NATION) return "personal";
	return "unknown";
}
// <-- KK

string GetNationNameByType(int iNationType)
{
	if (iNationType >= 0 && iNationType < NATIONS_QUANTITY)		// LDH fix for iNationType < 0
	{
		return Nations[iNationType].Name;
	}

	// added by KAM -->
	if (iNationType == NEUTRAL_NATION) { return "no nation"; }
	if (iNationType == UNKNOWN_NATION) { return "unknown nation"; }
	// <-- added by KAM
	if (iNationType == PERSONAL_NATION) { return "personal"; } // KK

	return "unknown"; // NK
}

// KK -->
string GetNationOfficialNameByType(int iNationType)
{
	string stmp;
	ref rPeriod; makeref(rPeriod, Periods[GetCurrentPeriod()]);
	if (iNationType >= 0 && iNationType < NATIONS_QUANTITY)		// LDH fix for iNationType < 0
	{
		stmp = Nations[iNationType].id;
		if (CheckAttribute(rPeriod, "Nations.OfficialName." + stmp)) return rPeriod.Nations.OfficialName.(stmp);
		return Nations[iNationType].Name;
	}

	// added by KAM -->
	if (iNationType == NEUTRAL_NATION) { return "no nation"; }
	if (iNationType == UNKNOWN_NATION) { return "unknown nation"; }
	// <-- added by KAM
	if (iNationType == PERSONAL_NATION) { return "personal"; } // KK

	return "unknown"; // NK
}
// <-- KK

ref GetNationByType(int iNationType)
{
	if (iNationType < 0) iNationType = PIRATE;		// LDH fix
	return &Nations[iNationType];
}

// RM Put these in Nations.c -->

//NEW PROPERTY: nation[n].Desc = adjective, i.e. French
//this returns it.
string GetNationDescByType(int iNationType)
{
	if (iNationType >= 0 && iNationType < NATIONS_QUANTITY) return Nations[iNationType].Desc; // LDH fix for iNationType < 0

	// added by KAM --> // KK -->
	switch (iNationType)
	{
	case NEUTRAL_NATION:  return "neutral";  break;
	case PERSONAL_NATION: return "personal"; break;
	}
	// <-- added by KAM // <-- KK

	return "unknown";
}


// KK -->
//NEW PROPERTY: Periods[n].Royal.(nation) = title, i.e. 'His Most Christian Majesty Charlie the _great'
//this returns it.
string GetNationRoyalByType(int iNationType)
{
	string sNation, sRet;
	ref rPeriod; makeref(rPeriod, Periods[GetCurrentPeriod()]);
	sRet = "";
	if (iNationType >= 0 && iNationType < NATIONS_QUANTITY)	// LDH fix for iNationType < 0
	{
		sNation = GetNationIDByType(iNationType);
		if (CheckAttribute(rPeriod, "Royal." + sNation + ".Title"))
		{
			sRet = rPeriod.Royal.(sNation).Title;
		}
		if (CheckAttribute(rPeriod, "Royal." + sNation + ".Name"))
		{
			if(sRet == "")	sRet  =       rPeriod.Royal.(sNation).Name;
			else			sRet += " " + rPeriod.Royal.(sNation).Name;
		}
		if(sRet == "") sRet = XI_ConvertString("unknown");
	}
	return sRet;
}
// <-- KK

//new property: nation[n].soldiergroup = first part of name for soldiers. For Hol + Por, it's name of island, not nation
string GetSoldiersName(int nation)
{
	if (nation < 0) return "";		// LDH fix
	if (nation == PERSONAL_NATION) return "PERSONAL"; // KK
	if(CheckAttribute(&Nations[nation],"soldiergroup")) return Nations[nation].soldiergroup;
	switch(nation)
	{
	case ENGLAND: return "ENGLAND"; break;
	case FRANCE: return "FRANCE"; break;
	case SPAIN: return "SPAIN"; break;
	case HOLLAND: return "DOUWESEN"; break;
	case PORTUGAL: return "CONCEICAO"; break;
	}
	return "";
}

string GetTownByNation(int iNation)
{
	int random;
	int i, j;
	string sTowns[100];
	string iTowns[100];

	j=0;
	for (i = 0; i < TOWNS_QUANTITY; i++)
	{
		string townid = Towns[i].id;
		if (GetTownNation(townid) == iNation)
		{
			sTowns[j] = Towns[i].name;
			iTowns[j] = Towns[i].id
			j++;
		}
	}
	if(j>0)
	{
		random = rand(j-1);
		return sTowns[random];
	}
	else
	{
		return "";
	}
}

//START RM CODE
//gets RMRelation between char and iNation
float GetRMRelation(ref char, int iNation)
{
	if (iNation == PERSONAL_NATION) return REL_NEUTRAL;
	string sNation = "" + iNation;
	float rel = REL_AMNESTY; // default to amnesty
	//if(sti(char.nation) == iNation) rel = REL_NEUTRAL;
	if(CheckAttribute(char, "nations."+sNation+".Relation"))
	{ rel = stf(char.nations.(sNation).Relation); }
	return rel;
}


//gets stock relation type based on RMRelation
int GetRMRelationType(float rel)
{
	if(rel <= REL_WAR) return RELATION_ENEMY;
	if(rel < REL_NEUTRAL) return RELATION_NEUTRAL;
	return RELATION_FRIEND;
}


//return name of relation, enemy->neutral->LoM->rank.
string GetRMRelationName(ref char, int iNation)
{
	float rel = GetRMRelation(char, iNation);
	// PB: Rewritten to prevent Letter of Marque text unless you actually have one -->
	if(rel <= REL_WAR)				return "Hostile";
	if(rel <= REL_AFTERATTACK)		return "Wary";
	if(GetRank(char, iNation))		return GetRankName(char, iNation);
	if(HaveLetterOfMarque(iNation))	return "Letter of Marque";
	if(rel < REL_NEUTRAL)			return "Neutral";
	if(rel >= REL_NEUTRAL)			return "Friendly";
	// PB: Rewritten to prevent Letter of Marque text unless you actually have one <--
}


//sets RMRelation between char and iNation to rel, sets
//stockrelation based on that, and logs if LogsToggle on. Requires NK - Toggles.
float SetRMRelation(ref char, int iNation, float rel)
{
	string sNation = "" + iNation;
	if (rel < REL_MIN) rel = REL_MIN;
	char.nations.(sNation).Relation = rel;

	//find new stockrelation and set.
	if(isMainCharacter(char)) SetNationRelation2MainCharacter(iNation, GetRMRelationType(rel));

	//log new relation
	if (iRealismMode == 0 && LogsToggle == LOG_VERBOSE) Log_SetStringToLog(XI_ConvertString(GetNationNameByType(iNation))+ " - " + XI_ConvertString(GetRMRelationName(char, iNation)) +"."); // PB: Fixes a dispay error // KK
	return rel;
}


//changes RMRelation between char and iNation, calling setRMR.
float ChangeRMRelation(ref char, int iNation, float relch)
{
	string sNation = "" + iNation;
	// KK -->
	if (ENABLE_FLAGS == 0) {
		relch += GetRMRelation(char, iNation);
	} else {
		relch += GetActualRMRelation(iNation);
	}
	// <-- KK
	if(relch < REL_MIN) relch = REL_MIN;
	char.nations.(sNation).Relation = relch;
	// KK -->
	if (ENABLE_FLAGS == 1) {
		SetActualRMRelation(iNation, relch);

		if (relch < 0)
		LooseLetterOfMarque(iNation);
	}
	// <-- KK

	//find new stockrelation and set.
	if(sti(char.index) == GetMainCharacterIndex()) SetNationRelation2MainCharacter(iNation, GetRMRelationType(relch));

	//log new relation
	//int tmpLangFileID = LanguageOpenFile("interface_strings.txt");
	if (iRealismMode == 0 && LogsToggle == LOG_VERBOSE) Log_SetStringToLog(XI_ConvertString(GetNationNameByType(iNation))+ " - " + TranslateString("",GetRMRelationName(char, iNation)) + "."); // KK
	//LanguageCloseFile(tmpLangFileID);
	return relch;
}

// 04-12-06 added
int RMGetHighestRelation(ref char)
{
	int bestnat = PIRATE;
	float tpoints = REL_MIN;
	// KK -->
	int i;
	if (ENABLE_FLAGS == 0) {
		for(i = 0; i < NATIONS_QUANTITY; i++) { if(GetRMRelation(&char, i) > tpoints) { tpoints = GetRMRelation(&char, i); bestnat = i; } }
	} else {
		for(i = 0; i < NATIONS_QUANTITY; i++) { if(GetActualRMRelation(i) > tpoints) { tpoints = GetActualRMRelation(i); bestnat = i; } }
	}
	// <-- KK
	if(tpoints < REL_AMNESTY) bestnat = PIRATE;
	return bestnat;
}


//gets cost for amnesty
int RMAmnestyCost(ref PChar, int iNation)
{
	// KK -->
	if (ENABLE_FLAGS == 0) {
		return makeint(sqrt(stf(PChar.rank)) * makefloat(GetRMRelation(PChar, iNation)) / stf(PChar.reputation) * 15000.0 / 100.0) * 100;
	} else {
		return makeint(sqrt(stf(PChar.rank)) * makefloat(GetActualRMRelation(iNation)) / stf(PChar.reputation) * 15000.0 / 100.0) * 100;
	}
	// <-- KK
}


//sets amnesty with iNation
void RMAmnesty(ref Pchar, int iNation)
{
	//use pchar at the moment
	Pchar = GetMainCharacter();
	SetRMRelation(&Pchar, iNation, REL_AMNESTY);
	// KK -->
	if (ENABLE_FLAGS == 1)
	SetActualRMRelation(iNation, REL_AMNESTY);
	// <-- KK
	if(GetSoldiersName(iNation) != "")
	{
		string PeaceGroup = GetSoldiersName(iNation) + "_SOLDIERS";
		LAi_group_SetRelation(PeaceGroup, LAI_GROUP_PLAYER, LAI_GROUP_FRIEND);
		//SetRMKills(&Pchar, iNation, 0);
	}
	// KK -->
	for (int i = 0; i < TOWNS_QUANTITY; i++) {
		string townid = Towns[i].id;
		if (GetTownNation(townid) == iNation) {
			int fortq = GetTownNumForts(townid) - 1;
			while (fortq >= 0) {
				SetCharacterRelationBoth(GetTownFortCommanderIndex(townid, fortq), GetMainCharacterIndex(), RELATION_FRIEND);
				fortq--;
			}
		}
	}
	// <-- KK
	UpdateRelations();
}


//gets RMRelation between char and gov.
float GetGovRelation(ref char, ref gov)
{
	float rel = 0.0;
	string id = gov.id;
	if(CheckAttribute(char,"GovRelations."+id))
	{ rel = stf(char.GovRelations.(id)); }
	return rel;
}


//sets RMRelation bgetween char and gov to rel.
float SetGovRelation(ref char, ref gov, float rel)
{
	string id = gov.id;
	if(rel < REL_MIN) rel = REL_MIN;
	char.GovRelations.(id) = rel;
	return rel;
}


//changes RMRelation between char and gov by relch.
float ChangeGovRelation(ref char, ref gov, float relch)
{
	string id = gov.id;
	relch += GetGovRelation(char, gov);
	if(relch < REL_MIN) relch = REL_MIN;
	char.GovRelations.(id) = relch;
	return relch;
}


//gets sum RMRelation between char, and gov /and gov's nation/,
//used to find if forts fire.
float GetRMRelationWithGov(ref char, ref gov)
{
	// KK -->
	if (ENABLE_FLAGS == 0) {
		return GetRMRelation(char, sti(gov.nation)) + GetGovRelation(char, gov);
	} else {
		return GetActualRMRelation(sti(gov.nation)) + GetGovRelation(char, gov);
	}
	// <-- KK
}


//find if fort should be hostile, based on char, and fortchar's governor.
// KK Never used anyway
int GovHostileCheck(ref char, ref fortchar)
{
	// KK -->
	if (CheckAttribute(fortchar, "town")) {
		int govidx = GetTownGovernorIndex(fortchar.town);
		if (govidx > -1) return GetRMRelationType(GetRMRelationWithGov(char, GetCharacter(govidx)));
		//	if(CheckAttribute(fortchar,"gov")) { return GetRMRelationType(GetRMRelationWithGov(char, CharacterFromID(fortchar.gov))); }
	}
	if (ENABLE_FLAGS == 0)
	return GetRMRelationType(GetRMRelation(char, sti(fortchar.nation)));
	else
	return GetRMRelationType(GetActualRMRelation(sti(fortchar.nation)));
	// <-- KK
}


/*NEW PROPERTY: in object Islands, for each Islands[n], where n is an inhabited island,
add property towns
add property towns.quantity = num towns on island
add property towns.i (where i is the number of the town) = town id.*/

//run this whenever friendly or neutral thing of iNation is /attacked/ by char.
float AttackRMRelation(ref char, int iNation)
{
	//init vars
	ref island;
	int govid[1];
	string townid[1];
	string tn;
	int tqty = 0;
	int govqty = 0;
	//ref gov;
	int i = 0;

	//find if near island and if so, get all govs on island.
	/*if(bIslandLoaded)
	{
		island = GetIslandByID(char.location);
		if(CheckAttribute(island,"towns.quantity")) tqty = sti(island.towns.quantity);
		if(tqty)
		{
			SetArraySize(&townid, tqty);
			string gstr;
			for(i = 1; i <= tqty; i++)
			{
				tn = i;
				townid[i] = island.towns.(tn);
				gstr = GetTownGovernorID(townid[i]);
				govqty++;
				SetArraySize(&govid, govqty);
				govid[govqty-1] = gstr;
			}
		}
		if(govqty)
		{
			// nothing yet
		}
	}*/

	// KK -->
	//get current rel
	float rel;
	if (ENABLE_FLAGS == 0) {
		rel = GetRMRelation(char, iNation);
	} else {
		rel = GetActualRMRelation(iNation);
	}
	// <-- KK
	bool bad = false;

	//set rmrel for iNation to afterattack.
	//note that REPCH_FRIENDLY is in /addition/ to RCH_neut.
	if(rel > REL_NEUTRAL)
	{
		ChangeCharacterReputation(&char, REPCH_FRIENDLY);
		if(sti(char.index) == GetMainCharacterIndex())
		{
			bad = true;
		}
	}
	if(rel > REL_AFTERATTACK)
	{
		SetRMRelation(&char, iNation, REL_AFTERATTACK);
		// KK -->
		if (ENABLE_FLAGS == 1)
		SetActualRMRelation(iNation, REL_AFTERATTACK);
		// <-- KK
		ChangeCharacterReputation(&char, REPCH_NEUTRAL);
	}
	LeaveService(&char, iNation, bad)
	//reset points for each gov if each gov is of iNation.
	/*if(govqty)
	{
		for(i = 0; i < govqty; i++)
		{
			ref gov = characterFromID(govid[i]);
			if(sti(gov.nation) == iNation && GetGovRelation(char, gov) > REL_NEUTRAL) SetGovRelation(&char, &gov, REL_NEUTRAL);
		}
	}*/
	return GetRMRelation(&char, iNation); // NK 04-09-20 func must return something, it's a float. Oops!
}

/* Explanation:
this changes relations based on an event (sink/take ship, sack/take town, etc.).
It adds points to all nations hostile to iNation (extra points if you have LoM)
and to all governors of those hostile nations from island if near island.*/
float UpdateRMRelation(ref char, int iNation, float fPoints)
{
	//init vars
	//ref island;
	//string govid[1];
	int govqty = 0;
	//ref gov;
	int i = 0;

	//find if near island and if so, get all govs on island.
	/*if(bIslandLoaded)
	{
		island = GetIslandByID(char.location);
		if(CheckAttribute(island,"towns.gov.quantity")) govqty = sti(island.towns.gov.quantity);
		if(govqty)
		{
			SetArraySize(govid, govqty);
			for(i = 0; i < govqty; i++) govid[i] = island.towns.gov.("gov"+i);
		}
	}*/

	// KK -->
	//get current rel
	float rel;
	if (ENABLE_FLAGS == 0) {
		rel = GetRMRelation(char, iNation);
	} else {
		rel = GetActualRMRelation(iNation);
	}
	// <-- KK

	//for govs
	float pirmult = 1.0;
	if(iNation == PIRATE) pirmult = 1.5;

	//Add points to char's nationrelations for each nation hostile to iNation;
	//if no LoM add only 1/4. If only neutral to that nation add only 1/8.
	//if near governors, add points in same way as above; with bonus if points were from attacking pirate.
	for(i = 0; i < NATIONS_QUANTITY; i++)
	{
		if(GetNationRelation(i, iNation) == RELATION_ENEMY)
		{
			// KK -->
			if (ENABLE_FLAGS == 0) {
				if(GetRMRelation(char, i) > REL_WAR && GetRMRelation(char, i) + (fPoints * NEUTRAL_POINTS) < REL_NEUTRAL)
				{
					ChangeRMRelation(&char, i, (fPoints * NEUTRAL_POINTS));
					/*if(govqty)
					{
						for(i = 0; i < govqty; i++)
						{
							ref gov = characterFromID(govid[i]);
							if(sti(gov.nation) == i)
							{
								ChangeGovRelation(&char, &gov, (fPoints * NEUTRAL_POINTS*pirmult));
							}
						}
					}*/
				}
				else
				{
					if(GetRMRelation(char, i) >= REL_NEUTRAL)
					{
						ChangeRMRelation(&char, i, (fPoints * FULL_POINTS));
						/*if(govqty)
						{
							for(i = 0; i < govqty; i++)
							{
								ref gov = characterFromID(govid[i]);
								if(sti(gov.nation) == i)
								{
									ChangeGovRelation(&char, &gov, (fPoints * FULL_POINTS *pirmult));
								}
							}
						}*/
					}

				}
			} else {
				if(GetActualRMRelation(i) > REL_WAR && GetActualRMRelation(i) + (fPoints * NEUTRAL_POINTS) < REL_NEUTRAL)
				{
					ChangeRMRelation(&char, i, (fPoints * NEUTRAL_POINTS));
					/*if(govqty)
					{
						for(i = 0; i < govqty; i++)
						{
							ref gov = characterFromID(govid[i]);
							if(sti(gov.nation) == i)
							{
								ChangeGovRelation(&char, &gov, (fPoints * NEUTRAL_POINTS*pirmult));
							}
						}
					}*/
				}
				else
				{
					if(GetActualRMRelation(i) >= REL_NEUTRAL)
					{
						ChangeRMRelation(&char, i, (fPoints * FULL_POINTS));
						/*if(govqty)
						{
							for(i = 0; i < govqty; i++)
							{
								ref gov = characterFromID(govid[i]);
								if(sti(gov.nation) == i)
								{
									ChangeGovRelation(&char, &gov, (fPoints * FULL_POINTS *pirmult));
								}
							}
						}*/
					}

				}
			}
			// <-- KK
		}
	}

	//subtract points from attacked nation
	if(rel > REL_WAR) ChangeRMRelation(&char, iNation, -(sqrt(fPoints) * NEUTRAL_MULT));
	else ChangeRMRelation(&char, iNation, -fPoints);

	//subtract points from each gov if each gov is of iNation.
	/*if(govqty)
	{
		for(i = 0; i < govqty; i++)
		{
			ref gov = characterFromID(govid[i]);
			if(sti(gov.nation) == iNation)
			{
				ChangeGovRelation(&char, &gov, -sqrt(fPoints));
			}
		}
	}*/

	//return new RMRelation
	return GetRMRelation(char, iNation);
}

// soldiers killed section
// used to see if soldiers actually should be hostile or not.
int GetRMKills(ref chr, int nat)
{
	int num = -1;
	string snat = nat;
	if(CheckAttribute(chr,"nation."+snat+".kills")) { num = sti(chr.nations.(snat).kills); }
	//else { chr.nations.(snat).kills = 0; }
	return num;
}

int SetRMKills(ref chr, int nat, int kills)
{
	int old = GetRMKills(&chr, nat);
	string snat = nat;
	chr.nations.(snat).kills = kills;
	DebugLog((kills) + " " + GetNationDescByType(nat) + " " + XI_ConvertString("soldiers killed") + ".");
	return old;
}

int ChangeRMKills(ref chr, int nat, int kills)
{
	string snat = nat;
	int old = GetRMKills(&chr, nat);
	if(old == -1) old = 0;
	old += kills;
	chr.nations.(snat).kills = kills;
	return kills;
}

string GetRMKillRelation(ref chr, int nat)
{
	if(GetRMKills(&chr, nat) >= RM_GROUP_MINKILLS) return LAI_GROUP_ENEMY;
	return LAI_GROUP_NEITRAL;
}

void SetAllSoldierGroups(ref chr)
{
	string groupname;
	for(int i = 0; i < NATIONS_QUANTITY; i++)
	{
		groupname = GetSoldiersName(i);
		if(groupname == "") continue;
		LAi_group_SetRelation(groupname + "_SOLDIERS", LAI_GROUP_PLAYER, GetRMKillRelation(&chr, i));
		DebugLog("setting " + groupname + " to " + GetRMKillRelation(&chr, i));
	}
}

// KK -->
int isSoldier(ref ch)
{
	if (!TestRef(ch)) return -1;
	if (CheckAttribute(ch, "isSoldier") && sti(ch.isSoldier) == true) {
		if (CheckAttribute(ch, "nation")) return sti(ch.nation);
		if (CheckAttribute(ch, "location")) return GetLocationNationFromID(ch.location);
		return GetCurrentLocationNation();
	}
	/*if (!CheckAttribute(ch, "chr_ai.group")) return -1;
	string group = ch.chr_ai.group;
	if (group == LAI_GROUP_GUARDS || group == LAI_GROUP_PATROL) {
		if (CheckAttribute(ch, "nation")) return sti(ch.nation);
		if (CheckAttribute(ch, "location")) return GetLocationNationFromID(ch.location);
		return GetCurrentLocationNation();
	}
	if (!HasSubStr(group, "_SOLDIERS")) return -1;
	if (group == "PERSONAL_SOLDIERS") return PERSONAL_NATION;
	for(int i = 0; i < NATIONS_QUANTITY; i++)
	{
		if(i == PIRATE) continue;
		if(GetSoldiersName(i) + "_SOLDIERS" == group) {
			if (CheckAttribute(ch, "nation")) return sti(ch.nation);
			if (CheckAttribute(ch, "location")) return GetLocationNationFromID(ch.location);
			return GetCurrentLocationNation();
		}
	}*/
	return UNKNOWN_NATION;
}
// <-- KK

bool AddOneSoldier(string group)
{
	if(group == "error" || group == "") return false;
	int nat = isSoldier(group);
	if(nat == UNKNOWN_NATION) return false;
	ChangeRMKills(GetMainCharacter(), nat, 1);
}
// RM <--

// KK -->
float ActualRMRelations[MAX_NATIONS];
float FlagRMRelations[MAX_NATIONS];
int iForceDetectionFalseFlag = 0;

// PB: Make Start New Game Nation Selection work -->
void SetRelationsAsNation(int iNation)
{
	int i;
	SetServedNation(iNation);
	if(iNation == PERSONAL_NATION)
	{
		for (i = 0; i < NATIONS_QUANTITY; i++) {
			if(i == PIRATE	)
			{
				ActualRMRelations[i] = REL_WAR;
				FlagRMRelations  [i] = REL_WAR;
			}
			else
			{
				ActualRMRelations[i] = REL_NEUTRAL-1;
				FlagRMRelations  [i] = REL_NEUTRAL-1;
			}
		}
	}
	else
	{
		for (i = 0; i < NATIONS_QUANTITY; i++) {
			if(i == iNation)	 ActualRMRelations[i] = REL_NEUTRAL;
			else				 ActualRMRelations[i] = RelationToRMRelation(GetNationRelation(iNation, i));
			FlagRMRelations[i] = ActualRMRelations[iNation];
		}
	}
}
// PB: Make Start New Game Nation Selection work <--

void SetServedNation(int iNation)
{
	ref PChar = GetMainCharacter();
	PChar.ServedNation = iNation;				// PB: Make sure this sticks
}

int GetServedNation()
{
	ref PChar = GetMainCharacter();
	if(!CheckAttribute(PChar, "ServedNation"))
	PChar.ServedNation = PERSONAL_NATION;		// PB: Don't serve anyone until you get a LoM (prevents missed attribute error)
	return sti(PChar.ServedNation);				// PB: Make sure this sticks
}

float GetActualRMRelation(int iNation)
{
	if ((iNation >= 0) && (iNation < NATIONS_QUANTITY))
	return ActualRMRelations[iNation];
	return REL_NEUTRAL;
}

string GetActualRMRelationName(ref char, int iNation)
{
	float rel = GetActualRMRelation(iNation);
	if(rel <= REL_WAR) return "Hostile";
	if(rel <= REL_AFTERATTACK) return "Wary"; //right now only this gets <=
	if(rel < REL_NEUTRAL) return "Neutral";
	if(!GetRank(char, iNation) && !HaveLetterOfMarque(iNation)) return "Friendly";
	if(!GetRank(char, iNation) && HaveLetterOfMarque(iNation)) return "Letter of Marque";
	return GetRankName(char, iNation);
}

void SetActualRMRelation(int iNation, float rel)
{
	if ((iNation >= 0) && (iNation < NATIONS_QUANTITY))
	ActualRMRelations[iNation] = rel;
}

int GetActualNationRelation2MainCharacter(int iNation)
{
	float rmrel;
	int rel;

	rmrel = GetActualRMRelation(iNation);
	rel = GetRMRelationType(rmrel);
	return rel;
}

float GetFlagRMRelation(int iNation)
{
	if (iNation >= 0 && iNation < NATIONS_QUANTITY)
	return FlagRMRelations[iNation];
	return REL_NEUTRAL;
}

void SetFlagRMRelation(int iNation, float rel)
{
	if ((iNation >= 0) && (iNation < NATIONS_QUANTITY))
	FlagRMRelations[iNation] = rel;
}

float RelationToRMRelation(int rel)
{
	switch (rel) {
	case RELATION_ENEMY:
		return REL_WAR;
		break;
	case RELATION_NEUTRAL:
		return REL_AMNESTY;
		break;
	case RELATION_FRIEND:
		return REL_NEUTRAL-1;
		break;
	}
}

void ReceiveLetterOfMarque(int iNation)
{
	ref PChar = GetMainCharacter();
	string sNation = ""+iNation;
	aref arTmp;
	if (iNation >= 0 && iNation < NATIONS_QUANTITY) {
		makearef(arTmp, PChar.nations.(sNation));
		arTmp.LoM = "1";
	}
}

void LooseLetterOfMarque(int iNation)
{
	ref PChar = GetMainCharacter();
	string sNation = ""+iNation;
	if (iNation >= 0 && iNation < NATIONS_QUANTITY) DeleteAttribute(PChar, "nations."+sNation+".LoM");
}

bool HaveLetterOfMarque(int iNation)
{
	ref PChar = GetMainCharacter();
	string sNation = ""+iNation;
	if ((iNation >= 0) && (iNation < NATIONS_QUANTITY))
	return CheckAttribute(PChar, "nations."+sNation+".LoM");
	return false;
}

// PB -->
bool HaveAnyLetterOfMarque()
{
	for (int i=0; i<NATIONS_QUANTITY; i++)
	{
		if (i == PIRATE) continue;
		if (HaveLetterOfMarque(i)) return true;
	}
	return false;
}
// PB <--

int GetCurrentFlag()
{
	return sti(characters[GetMainCharacterIndex()].nation);
}

void HoistFlag(int iNation)
{
	int rel;
	int i;

	if (iNation == PERSONAL_NATION) {
		for (i = 0; i < NATIONS_QUANTITY; i++)
		{
			SetFlagRMRelation(i, GetActualRMRelation(i));
		}
		return;
	}

	for (i = 0; i < NATIONS_QUANTITY; i++)
	{
		if (i != iNation) {
			rel = GetNationRelation(iNation, i);
			SetFlagRMRelation(i, RelationToRMRelation(rel));
		} else {
			SetFlagRMRelation(iNation, REL_NEUTRAL - 1.0);
		}
	}
}

void SetRelationsForFlag(int iNation)
{
	ref PChar = GetMainCharacter();
	int i;
	float rel;

	for (i = 0; i < NATIONS_QUANTITY; i++) {
		rel = GetFlagRMRelation(i);
		SetRMRelation(PChar, i, rel);
		SetNationRelation2MainCharacter(i, GetRMRelationType(rel));
	}

	if (iNation != PERSONAL_NATION) {
		if (HaveLetterOfMarque(iNation)) {
			SetRMRelation(PChar, iNation, GetActualRMRelation(iNation));
			SetNationRelation2MainCharacter(iNation, RELATION_FRIEND);
		}
	} else {
		for (i = 0; i < NATIONS_QUANTITY; i++) {
			if (i == PIRATE) continue;
			if (HaveLetterOfMarque(i)) {
				SetRMRelation(PChar, i, GetActualRMRelation(i));
				SetNationRelation2MainCharacter(i, RELATION_FRIEND);
			}
		}
	}

	UpdateRelations();
}

float GetChanceDetectFalseFlag()
{
	// original code -->
	//	float rank = GetRankFromPoints(GetScore(GetMainCharacter()));
	//	return CHANCE_DETECT_FALSE_FLAG_BASE+(CHANCE_DETECT_FALSE_FLAG_MAX-CHANCE_DETECT_FALSE_FLAG_BASE)*rank/MAX_RANK;
	// original code <--

	// LDH -->
	ref mchr = GetMainCharacter(); // KK
	float score  = GetScore(mchr); // KK
	float rank   = GetRankFromPoints(score);
	int   sneak  = GetSummonSkillFromName(mchr, SKILL_SNEAK);
	int difficulty = GetDifficulty();
	float chance = rank/MAX_RANK * (11.0-sneak)/10.0;
	chance = chance * difficulty/2.0;		// 0.5, 1.0, 1.5, 2.0
	//	chance = chance * (difficulty+1)/3.0;		// alternate difficulty calculation 0.67, 1,0, 1.33, 1.67
	chance = fclamp(CHANCE_DETECT_FALSE_FLAG_BASE, CHANCE_DETECT_FALSE_FLAG_MAX, chance); // PURSEON: so chance doesn't go over min/max
	//	LogIt("False Flag Detection - Score: " + score + ", rank: " + rank + ", Sneak: " + sneak + ", Chance: " + chance*100.0 + "%"); // for testing
	//	LogIt("The chance of your false flag being detected is " + chance*100.0 + "%");	// Tell the player, it might get him used to looking for it.
	return chance;
	// LDH <--
}

void SetNationRelation2Blaze(int iNation, int rel)
{
	if (iNation >= 0 && iNation < NATIONS_QUANTITY) {
		SetNationRelation2MainCharacter(iNation, rel);
		SetActualRMRelation(iNation, RelationToRMRelation(rel));
		UpdateRelations();
	}
}

string GetSoldiersDialog(int nation, string town)
{
	string dialogfile = "";
	switch(nation) {
	case ENGLAND:
		switch (town) {
		case "Oxbay":
			dialogfile = "Oxbay";
			break;
		case "Greenford":
			dialogfile = "Greenford";
			break;
		case "Charlestown":
			dialogfile = "Oxbay";
			break;
			// default:
			dialogfile = "Redmond";
		}
		break;
	case FRANCE:
		dialogfile = "Falaise De Fleur";
		break;
	case SPAIN:
		dialogfile = "Isla Muelle";
		break;
	case HOLLAND:
		dialogfile = "Douwesen";
		break;
	case PORTUGAL:
		dialogfile = "Conceicao";
		break;
	case PERSONAL_NATION:
		dialogfile = "Personal";
		break;
		// default:
		dialogfile = GetNationIDByType(nation);
	}
	return dialogfile + " Soldier_dialog.c";
}

string GetSoldiersGreeting(int nation, string town)
{
	string greeting = "";
	switch(nation) {
	case ENGLAND:
		switch (town) {
		case "Oxbay":
			greeting = "Oxbay";
			break;
		case "Greenford":
			greeting = "Greenford";
			break;
		case "Charlestown":
			greeting = "Charlestown";
			break;
			// default:
			greeting = "Redmond";
		}
		break;
	case FRANCE:
		greeting = "Falaise De Fleur";
		break;
	case SPAIN:
		greeting = "Isla Muelle";
		break;
	case HOLLAND:
		greeting = "Douwesen";
		break;
	case PORTUGAL:
		greeting = "Conceicao";
		break;
	case PERSONAL_NATION:
		greeting = "Redmond";
		break;
		// default:
		greeting = GetNationIDByType(nation);
	}
	return "Gr_" + greeting + " Soldier";
}

string GetCitizensName(int nation)
{
	switch(nation)
	{
	case ENGLAND: return "ENGLAND"; break;
	case FRANCE: return "FRANCE"; break;
	case SPAIN: return "SPAIN"; break;
	case HOLLAND: return "DOUWESEN"; break;
	case PORTUGAL: return "CONCEICAO"; break;
	case PERSONAL_NATION: return "PERSONAL"; break;
	}
	return "";
}

void InitRelations()
{
	string initfile = "";
	string slpath = GetStorylinePath(FindCurrentStoryline());
	if (FindFile("PROGRAM\" + slpath + "Nations", "*.c", "relations_init.c") != "") {
		initfile = slpath + "Nations\relations_init.c";
		if (LoadSegment(initfile)) {
			relations_init();
			UnloadSegment(initfile);
		}
	} else {
		initfile = "Nations\relations_init.c";
		if (LoadSegment(initfile)) {
			relations_init();
			UnloadSegment(initfile);
		}
	}
}

void InitGroups()
{
	LAi_group_SetRelation("CONCEICAO_SOLDIERS", "CONCEICAO_CITIZENS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("CONCEICAO_SOLDIERS", "CONCEICAO_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("CONCEICAO_SOLDIERS", LAI_DEFAULT_GROUP, LAI_GROUP_FRIEND);
	LAi_group_SetAlarmReaction("CONCEICAO_SOLDIERS", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY, LAI_GROUP_FRIEND);
	LAi_group_SetAlarmReaction("CONCEICAO_SOLDIERS", "CONCEICAO_CITIZENS", LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetLookRadius("CONCEICAO_SOLDIERS", LAI_GROUP_GRD_LOOK);
	LAi_group_SetHearRadius("CONCEICAO_SOLDIERS", LAI_GROUP_GRD_HEAR);
	LAi_group_SetSayRadius("CONCEICAO_SOLDIERS", LAI_GROUP_GRD_SAY);
	LAi_group_SetPriority("CONCEICAO_CITIZENS", LAI_GROUP_PCITIZENS);
	LAi_group_SetPriority("CONCEICAO_SOLDIERS", LAI_GROUP_PGUARDS);

	LAi_group_SetLookRadius("CONCEICAO_CITIZENS", LAI_GROUP_DEF_LOOK);
	LAi_group_SetHearRadius("CONCEICAO_CITIZENS", LAI_GROUP_DEF_HEAR);
	LAi_group_SetSayRadius("CONCEICAO_CITIZENS", LAI_GROUP_DEF_SAY);

	LAi_group_SetAlarmReaction("SMUGGLERS_SOLDIERS", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("SMUGGLERS_SOLDIERS", "SMUGGLERS_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("SMUGGLERS_CITIZENS", "SMUGGLERS_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("SMUGGLERS_SOLDIERS", LAI_DEFAULT_GROUP, LAI_GROUP_FRIEND);
	LAi_group_SetLookRadius("SMUGGLERS_SOLDIERS", LAI_GROUP_GRD_LOOK);
	LAi_group_SetHearRadius("SMUGGLERS_SOLDIERS", LAI_GROUP_GRD_HEAR);
	LAi_group_SetSayRadius("SMUGGLERS_SOLDIERS", LAI_GROUP_GRD_SAY);
	LAi_group_SetAlarmReaction("SMUGGLERS_SOLDIERS", "SMUGGLERS_CITIZENS", LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetPriority("SMUGGLERS_CITIZENS", LAI_GROUP_PCITIZENS);
	LAi_group_SetPriority("SMUGGLERS_SOLDIERS", LAI_GROUP_PGUARDS);

	LAi_group_SetLookRadius("SMUGGLERS_CITIZENS", LAI_GROUP_DEF_LOOK);
	LAi_group_SetHearRadius("SMUGGLERS_CITIZENS", LAI_GROUP_DEF_HEAR);
	LAi_group_SetSayRadius("SMUGGLERS_CITIZENS", LAI_GROUP_DEF_SAY);

	LAi_group_SetAlarmReaction("DOUWESEN_SOLDIERS", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("DOUWESEN_CITIZENS", "DOUWESEN_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("DOUWESEN_SOLDIERS", "DOUWESEN_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("DOUWESEN_SOLDIERS", LAI_DEFAULT_GROUP, LAI_GROUP_FRIEND);
	LAi_group_SetLookRadius("DOUWESEN_SOLDIERS", LAI_GROUP_GRD_LOOK);
	LAi_group_SetHearRadius("DOUWESEN_SOLDIERS", LAI_GROUP_GRD_HEAR);
	LAi_group_SetSayRadius("DOUWESEN_SOLDIERS", LAI_GROUP_GRD_SAY);
	LAi_group_SetAlarmReaction("DOUWESEN_SOLDIERS", "DOUWESEN_CITIZENS", LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetPriority("DOUWESEN_CITIZENS", LAI_GROUP_PCITIZENS);
	LAi_group_SetPriority("DOUWESEN_SOLDIERS", LAI_GROUP_PGUARDS);

	LAi_group_SetLookRadius("DOUWESEN_SOLDIERS", LAI_GROUP_DEF_LOOK);
	LAi_group_SetHearRadius("DOUWESEN_SOLDIERS", LAI_GROUP_DEF_HEAR);
	LAi_group_SetSayRadius("DOUWESEN_SOLDIERS", LAI_GROUP_DEF_SAY);

	LAi_group_SetAlarmReaction("DOUWESEN_PIRATE_SOLDIERS", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("DOUWESEN_PIRATE_SOLDIERS", "DOUWESEN_PIRATE_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("DOUWESEN_PIRATE_CITIZENS", "DOUWESEN_PIRATE_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("DOUWESEN_PIRATE_SOLDIERS", LAI_DEFAULT_GROUP, LAI_GROUP_FRIEND);
	LAi_group_SetLookRadius("DOUWESEN_PIRATE_SOLDIERS", LAI_GROUP_GRD_LOOK);
	LAi_group_SetHearRadius("DOUWESEN_PIRATE_SOLDIERS", LAI_GROUP_GRD_HEAR);
	LAi_group_SetSayRadius("DOUWESEN_PIRATE_SOLDIERS", LAI_GROUP_GRD_SAY);
	LAi_group_SetAlarmReaction("DOUWESEN_PIRATE_SOLDIERS", "DOUWESEN_PIRATE_CITIZENS", LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetPriority("DOUWESEN_PIRATE_CITIZENS", LAI_GROUP_PCITIZENS);
	LAi_group_SetPriority("DOUWESEN_PIRATE_SOLDIERS", LAI_GROUP_PGUARDS);

	LAi_group_SetLookRadius("DOUWESEN_PIRATE_CITIZENS", LAI_GROUP_DEF_LOOK);
	LAi_group_SetHearRadius("DOUWESEN_PIRATE_CITIZENS", LAI_GROUP_DEF_HEAR);
	LAi_group_SetSayRadius("DOUWESEN_PIRATE_CITIZENS", LAI_GROUP_DEF_SAY);

	LAi_group_SetAlarmReaction("FRANCE_SOLDIERS", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("FRANCE_CITIZENS", "FRANCE_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("FRANCE_SOLDIERS", "FRANCE_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("FRANCE_SOLDIERS", LAI_DEFAULT_GROUP, LAI_GROUP_FRIEND);
	LAi_group_SetLookRadius("FRANCE_SOLDIERS", LAI_GROUP_GRD_LOOK);
	LAi_group_SetHearRadius("FRANCE_SOLDIERS", LAI_GROUP_GRD_HEAR);
	LAi_group_SetSayRadius("FRANCE_SOLDIERS", LAI_GROUP_GRD_SAY);
	LAi_group_SetAlarmReaction("FRANCE_SOLDIERS", "FRANCE_CITIZENS", LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetPriority("FRANCE_CITIZENS", LAI_GROUP_PCITIZENS);
	LAi_group_SetPriority("FRANCE_SOLDIERS", LAI_GROUP_PGUARDS);

	LAi_group_SetLookRadius("FRANCE_CITIZENS", LAI_GROUP_DEF_LOOK);
	LAi_group_SetHearRadius("FRANCE_CITIZENS", LAI_GROUP_DEF_HEAR);
	LAi_group_SetSayRadius("FRANCE_CITIZENS", LAI_GROUP_DEF_SAY);

	LAi_group_SetAlarmReaction("SPAIN_SOLDIERS", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("SPAIN_CITIZENS", "SPAIN_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("SPAIN_SOLDIERS", "SPAIN_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("SPAIN_SOLDIERS", LAI_DEFAULT_GROUP, LAI_GROUP_FRIEND);
	LAi_group_SetLookRadius("SPAIN_SOLDIERS", LAI_GROUP_GRD_LOOK);
	LAi_group_SetHearRadius("SPAIN_SOLDIERS", LAI_GROUP_GRD_HEAR);
	LAi_group_SetSayRadius("SPAIN_SOLDIERS", LAI_GROUP_GRD_SAY);
	LAi_group_SetAlarmReaction("SPAIN_SOLDIERS", "SPAIN_CITIZENS", LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetPriority("SPAIN_CITIZENS", LAI_GROUP_PCITIZENS);
	LAi_group_SetPriority("SPAIN_SOLDIERS", LAI_GROUP_PGUARDS);

	LAi_group_SetLookRadius("SPAIN_CITIZENS", LAI_GROUP_DEF_LOOK);
	LAi_group_SetHearRadius("SPAIN_CITIZENS", LAI_GROUP_DEF_HEAR);
	LAi_group_SetSayRadius("SPAIN_CITIZENS", LAI_GROUP_DEF_SAY);

	LAi_group_SetAlarmReaction("ENGLAND_SOLDIERS", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("ENGLAND_CITIZENS", "ENGLAND_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("ENGLAND_SOLDIERS", "ENGLAND_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("ENGLAND_SOLDIERS", LAI_DEFAULT_GROUP, LAI_GROUP_FRIEND);
	LAi_group_SetLookRadius("ENGLAND_SOLDIERS", LAI_GROUP_GRD_LOOK);
	LAi_group_SetHearRadius("ENGLAND_SOLDIERS", LAI_GROUP_GRD_HEAR);
	LAi_group_SetSayRadius("ENGLAND_SOLDIERS", LAI_GROUP_GRD_SAY);
	LAi_group_SetAlarmReaction("ENGLAND_SOLDIERS", "ENGLAND_CITIZENS", LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetPriority("ENGLAND_CITIZENS", LAI_GROUP_PCITIZENS);
	LAi_group_SetPriority("ENGLAND_SOLDIERS", LAI_GROUP_PGUARDS);

	LAi_group_SetLookRadius("ENGLAND_CITIZENS", LAI_GROUP_DEF_LOOK);
	LAi_group_SetHearRadius("ENGLAND_CITIZENS", LAI_GROUP_DEF_HEAR);
	LAi_group_SetSayRadius("ENGLAND_CITIZENS", LAI_GROUP_DEF_SAY);

	LAi_group_SetAlarmReaction("AMERICA_SOLDIERS", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("AMERICA_CITIZENS", "AMERICA_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("AMERICA_SOLDIERS", "AMERICA_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("AMERICA_SOLDIERS", LAI_DEFAULT_GROUP, LAI_GROUP_FRIEND);
	LAi_group_SetLookRadius("AMERICA_SOLDIERS", LAI_GROUP_GRD_LOOK);
	LAi_group_SetHearRadius("AMERICA_SOLDIERS", LAI_GROUP_GRD_HEAR);
	LAi_group_SetSayRadius("AMERICA_SOLDIERS", LAI_GROUP_GRD_SAY);
	LAi_group_SetAlarmReaction("AMERICA_SOLDIERS", "AMERICA_CITIZENS", LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetPriority("AMERICA_CITIZENS", LAI_GROUP_PCITIZENS);
	LAi_group_SetPriority("AMERICA_SOLDIERS", LAI_GROUP_PGUARDS);

	LAi_group_SetLookRadius("AMERICA_CITIZENS", LAI_GROUP_DEF_LOOK);
	LAi_group_SetHearRadius("AMERICA_CITIZENS", LAI_GROUP_DEF_HEAR);
	LAi_group_SetSayRadius("AMERICA_CITIZENS", LAI_GROUP_DEF_SAY);

	LAi_group_SetAlarmReaction("QC_SOLDIERS", LAI_GROUP_PLAYER, LAI_GROUP_ENEMY, LAI_GROUP_FRIEND);
	LAi_group_SetRelation("QC_CITIZENS", "QC_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("QC_SOLDIERS", "QC_SOLDIERS", LAI_GROUP_FRIEND);
	LAi_group_SetRelation("QC_SOLDIERS", LAI_DEFAULT_GROUP, LAI_GROUP_FRIEND);
	LAi_group_SetLookRadius("QC_SOLDIERS", LAI_GROUP_GRD_LOOK);
	LAi_group_SetHearRadius("QC_SOLDIERS", LAI_GROUP_GRD_HEAR);
	LAi_group_SetSayRadius("QC_SOLDIERS", LAI_GROUP_GRD_SAY);
	LAi_group_SetAlarmReaction("QC_SOLDIERS", "QC_CITIZENS", LAI_GROUP_FRIEND, LAI_GROUP_FRIEND);
	LAi_group_SetPriority("QC_CITIZENS", LAI_GROUP_PCITIZENS);
	LAi_group_SetPriority("QC_SOLDIERS", LAI_GROUP_PGUARDS);

	LAi_group_SetLookRadius("QC_CITIZENS", LAI_GROUP_DEF_LOOK);
	LAi_group_SetHearRadius("QC_CITIZENS", LAI_GROUP_DEF_HEAR);
	LAi_group_SetSayRadius("QC_CITIZENS", LAI_GROUP_DEF_SAY);

	string slpath = GetStorylinePath(FindCurrentStoryline());
	if (FindFile("PROGRAM\" + slpath + "NATIONS", "*.c", "groups_init.c") != "") {
		if (LoadSegment(slpath + "NATIONS\groups_init.c")) {
			groups_init();
			UnloadSegment(slpath + "NATIONS\groups_init.c");
		}
	}
}

bool CheckGuestNation(int iGuestNation, int iNation)
{
	int i;
	if (iGuestNation >= GUEST1_NATION && iGuestNation <= GUEST2_NATION) {
		for (i = 0; i < NATIONS_QUANTITY; i++)
		{
			if (GetFlagIndex(i) == iGuestNation) return true;
		}
	}
	return false;
}

void SetNationRelationChangeEnable(int iNation1, int iNation2, bool bEnable)
{
	string stmp;
	if (iNation1 == iNation2 || iNation1 < 0 || iNation1 >= NATIONS_QUANTITY || iNation2 < 0 || iNation2 >= NATIONS_QUANTITY) return;
	stmp = "n" + iNation2;
	if (bEnable) {
		if (CheckAttribute(&Nations[iNation1], "Relations." + stmp + ".lock")) DeleteAttribute(&Nations[iNation1], "Relations." + stmp + ".lock");
		stmp = "n" + iNation1;
		if (CheckAttribute(&Nations[iNation2], "Relations." + stmp + ".lock")) DeleteAttribute(&Nations[iNation2], "Relations." + stmp + ".lock");
	} else {
		Nations[iNation1].Relations.(stmp).lock = true;
		stmp = "n" + iNation1
		Nations[iNation2].Relations.(stmp).lock = true;
	}
}

bool isNationRelationChangeEnabled(int iNation1, int iNation2)
{
	string stmp = "n" + iNation1;
	bool bEnable = true;
	if (iNation1 == iNation2 || iNation1 < 0 || iNation1 >= NATIONS_QUANTITY || iNation2 < 0 || iNation2 >= NATIONS_QUANTITY) return false;
	if (!CheckAttribute(&Nations[iNation1], "Relations." + stmp + ".lock")) {
		stmp = "n" + iNation2;
		if (!CheckAttribute(&Nations[iNation2], "Relations." + stmp + ".lock")) return true;
	}
	return false;
}

int CheckNationsQuantity(int iPeriod)
{
	int iNationsQuantity = 6;
	ref rPeriod; makeref(rPeriod, Periods[iPeriod]);

	bGuest1NationExists = CheckAttribute(rPeriod, "Nations.Guest1");
	bGuest2NationExists = CheckAttribute(rPeriod, "Nations.Guest2");

	if (bGuest1NationExists)
		iNationsQuantity++;
	else
		Nations[GUEST1_NATION].disabled = true;
	if (bGuest2NationExists)
		iNationsQuantity++;
	else
		Nations[GUEST2_NATION].disabled = true;

	return iNationsQuantity;
}

string CheckNationNameByPeriod(int iNation, int iPeriod, bool bOfficial)
{
	string id = "";
	ref rPeriod; makeref(rPeriod, Periods[iPeriod]);
	if (iNation == GUEST1_NATION && CheckAttribute(rPeriod, "Nations.Guest1") == true) {
		id = "Guest1";
	} else {
		if (iNation == GUEST2_NATION && CheckAttribute(rPeriod, "Nations.Guest2") == true) {
			id = "Guest2";
		} else {
			id = GetNationIDByType(iNation);
		}
	}
	if (bOfficial) {
		if (CheckAttribute(rPeriod, "Nations.OfficialName." + id)) return rPeriod.Nations.OfficialName.(id);
	} else {
		if (CheckAttribute(rPeriod, "Nations." + id)) return rPeriod.Nations.(id);
	}
	return GetNationNameByType(iNation);
}

int GetFlagIndex(int iNation)
{
	ref rNation;
	if (iNation >= 0 && iNation < NATIONS_QUANTITY) {
		makeref(rNation, Nations[iNation]);
		if (CheckAttribute(rNation, "FlagIdx")) return sti(rNation.FlagIdx);
	}
	return iNation;
}
// <-- KK

// Sulan: Improved Random Relations code -->
void RandomNationsRelationsChange()
{
	int i,j;
	int newRelation = RELATION_UNKNOWN;
	int random;
	ref pchar = GetMainCharacter();
	string logTitle;
	string logEntry;

	// PB: Rewritten to a maximum of one change per day -->
	if(rand(1000) < RELATION_CHANGE_PROBABILITY*10)		// do relation change
	{
		// STEP 1: Find nations for relation change
		i = PERSONAL_NATION;
		j = PERSONAL_NATION;
		while(i==PERSONAL_NATION || i==PIRATE)				// Pirate relation doesn't change
		{
			i = rand(NATIONS_QUANTITY-1);
		}
		while(j==PERSONAL_NATION || j==PIRATE || i==j)		// Also don't change relation to same nation
		{
			j = rand(NATIONS_QUANTITY-1);
		}

		// STEP 2: Figure out what to do with them
		switch(GetNationRelation(i,j))
		{
			case RELATION_ENEMY:
				logTitle = GetNationNameByType(i)+" and "+GetNationNameByType(j)+" make peace";
				logEntry = "After some time of bloody warfare "+GetNationNameByType(i)+" and "+GetNationNameByType(j)+" have declared a ceasefire.";
				if(GetNationRelation2MainCharacter(i)==RELATION_FRIEND && GetNationRelation2MainCharacter(j)==RELATION_FRIEND) logEntry += " This is good news as it was a very hard time to keep friendly relations with two warfaring parties.";
				if(GetServedNation()==i && GetNationRelation2MainCharacter(j)==RELATION_ENEMY) logEntry += "\n \nAlthough good news in general, this is bad news for me. Attacking "+GetNationDescByType(j)+" ships and towns will not raise my reputation with the "+GetNationDescByType(i)+" anymore.";
				if(GetServedNation()==j && GetNationRelation2MainCharacter(i)==RELATION_ENEMY) logEntry += "\n \nAlthough good news in general, this is bad news for me. Attacking "+GetNationDescByType(i)+" ships and towns will not raise my reputation with the "+GetNationDescByType(j)+" anymore.";
				WriteNewLogEntry(logTitle, logEntry, "General",false);
				newRelation = RELATION_NEUTRAL;
				break;
			case RELATION_NEUTRAL:
				random = rand(2);
				if(random==0)
				{
					logTitle = GetNationNameByType(i)+" and "+GetNationNameByType(j)+" have allied";
					logEntry = GetNationNameByType(i)+" and "+GetNationNameByType(j)+" have formed an alliance. Attacking ships or towns of either nation will also decrease the standing with the ally.";
					if(GetNationRelation2MainCharacter(i)==RELATION_FRIEND && GetNationRelation2MainCharacter(j)==RELATION_FRIEND) logEntry += " Very good news, indeed. Working for the "+GetNationDescByType(i)+" and the "+GetNationDescByType(j)+", as I currently do, my deeds will raise my standing with both nations.";
					if(GetNationRelation2MainCharacter(i)==RELATION_ENEMY && GetNationRelation2MainCharacter(j)==RELATION_ENEMY) logEntry += " Whoops! It seems I have bothered them a little too much. But their alliance won't stop me.";
					if(GetServedNation()==i && GetNationRelation2MainCharacter(j)==RELATION_ENEMY) logEntry += "\n \nThis makes working for the "+GetNationDescByType(i)+" somewhat more difficult, as sinking "+GetNationDescByType(j)+" ships is no longer an option.";
					if(GetServedNation()==j && GetNationRelation2MainCharacter(i)==RELATION_ENEMY) logEntry += "\n \nThis makes working for the "+GetNationDescByType(j)+" somewhat more difficult, as sinking "+GetNationDescByType(i)+" ships is no longer an option.";
					WriteNewLogEntry(logTitle, logEntry, "General",false);
					newRelation = RELATION_FRIEND;
				}
				if(random==1)  // i declared war on j
				{
					logTitle = GetNationNameByType(i)+" is at war with "+GetNationNameByType(j);
					logEntry = GetNationNameByType(i)+" has declared war on "+GetNationNameByType(j)+". "+GetNationDescByType(i)+" ships have attacked a small "+GetNationDescByType(j)+" settlement, as I was told.";
					if(GetServedNation()==i && GetNationRelation2MainCharacter(j)==RELATION_ENEMY) logEntry += "\n \nIt was about time to show those "+GetNationDescByType(j)+" landlubbers who's in charge in the caribbean!";
					if(GetServedNation()==j && GetNationRelation2MainCharacter(i)==RELATION_ENEMY) logEntry += "\n \nThose bloody cowards! The next "+GetNationDescByType(i)+" ship we encounter will surely pay for this.";
					WriteNewLogEntry(logTitle, logEntry, "General",false);
					newRelation = RELATION_ENEMY;
				}
				if(random==2)  // j declared war on i
				{
					logTitle = GetNationNameByType(j)+" is at war with "+GetNationNameByType(i);
					logEntry = GetNationNameByType(j)+" has declared war on "+GetNationNameByType(i)+". "+GetNationDescByType(j)+" troops have landed near  "+GetTownByNation(i)+", as I was told.";
					if(GetServedNation()==i && GetNationRelation2MainCharacter(j)==RELATION_ENEMY) logEntry += "\n \nThose bloody cowards! The next "+GetNationDescByType(j)+" ship we encounter will surely pay for this.";
					if(GetServedNation()==j && GetNationRelation2MainCharacter(i)==RELATION_ENEMY) logEntry += "\n \nIt was about time to show those "+GetNationDescByType(i)+" landlubbers who's in charge in the caribbean!";
					WriteNewLogEntry(logTitle, logEntry, "General",false);
					newRelation = RELATION_ENEMY;
				}
				break;
			case  RELATION_FRIEND:
				random = rand(2);
				if(random==0)
				{
					logTitle = GetNationNameByType(i)+" and "+GetNationNameByType(j)+" broke their alliance";
					logEntry = GetNationNameByType(i)+" and "+GetNationNameByType(j)+" have broken their alliance, but are currently peaceful. Observers report military activity on both sides, but so far an open conflict has been avoided.";
					newRelation = RELATION_NEUTRAL;
				}
				if(random==1) // i broke the alliance
				{
					logTitle = GetNationNameByType(i)+" and "+GetNationNameByType(j)+" broke their alliance";
					logEntry = GetNationNameByType(i)+" and "+GetNationNameByType(j)+" have broken their alliance and are now at war! It was reported that "+GetNationNameByType(i)+" broke the alliance by "+GetBreakAllianceReason(i,j);
					if(GetServedNation()==j && GetNationRelation2MainCharacter(i)==RELATION_ENEMY) logEntry += "\n \nThose treacherous bastards! The "+GetNationDescByType(i)+" will pay for this betrayal. I have ordered to open fire on sight of any "+GetNationDescByType(i)+" ship.";
					WriteNewLogEntry(logTitle, logEntry, "General",false);
					newRelation = RELATION_NEUTRAL;
				}
				if(random==2) // j broke the alliance
				{
					logTitle = GetNationNameByType(j)+" and "+GetNationNameByType(i)+" broke their alliance";
					logEntry = GetNationNameByType(j)+" and "+GetNationNameByType(i)+" have broken their alliance and are now at war! It was reported that "+GetNationNameByType(j)+" broke the alliance by "+GetBreakAllianceReason(j,i);
					if(GetServedNation()==i && GetNationRelation2MainCharacter(j)==RELATION_ENEMY) logEntry += "\n \nThose treacherous bastards! The "+GetNationDescByType(j)+" will pay for this betrayal. I have ordered to open fire on sight of any "+GetNationDescByType(j)+" ship.";
					WriteNewLogEntry(logTitle, logEntry, "General",false);
					newRelation = RELATION_ENEMY;
				}
			break;
		}

		// STEP 3: Change relation and match player if required
		SetNationRelationBoth(i, j, newRelation);
		if(CheckAttribute(pchar, "professionalnavy"))	// For Commissioned Naval Officers
		{
			if(i == GetServedNation()) i = j;			// Don't change your relation to your OWN nation
			switch(newRelation)
			{
				case RELATION_ENEMY:
					SetActualRMRelation(i, REL_WAR);
				break;
				case RELATION_NEUTRAL:
					SetActualRMRelation(i, REL_AFTERATTACK);
				break;
				case RELATION_FRIEND:
					SetActualRMRelation(i, REL_AMNESTY);
				break;
			}
		}
	}
	// PB: Rewritten to a maximum of one change per day <--
}

string GetBreakAllianceReason(int traitor, int victim)
{
	int random;

	string sReasons[6];
	sReasons[0] = "'accidently' sinking the "+GetNationDescByType(victim)+" military supply convoy.";
	sReasons[1] = "treating the "+GetNationDescByType(victim)+" ambassador in a 'disrespectful' manner, as was reported from Europe.";
	sReasons[2] = "brutally burning down a small settlement of the "+GetNationDescByType(victim)+", leaving no one alive (I am curious how they got this report then?).";
	sReasons[3] = "officially knighting a notorious freebooter, who plundered the "+GetNationDescByType(victim)+" colonies in the previous war.";
	sReasons[4] = "inciting a slave revolt in a major "+GetNationDescByType(victim)+" colony.";
	sReasons[5] = "sending a horde of French squirrels with blond wigs to pillage a Spanish monastery.\n \n This doesn't make any sense at all and does not really explain why "+GetNationNameByType(traitor)+" broke their alliance, but that's what they did.";

	random = rand(5);
	return sReasons[random];
}
// <-- Sulan
